#pragma once

#include "GLTypes.h"

class CubeMapTexture
{
private:

	GLuint _handle;
	int _width, _height;
	bool _srgb;

public:
	CubeMapTexture(	unsigned int width, unsigned int height, 
					const unsigned char* face_x_pos, const unsigned char* face_x_neg, 
					const unsigned char* face_y_pos, const unsigned char* face_y_neg, 
					const unsigned char* face_z_pos, const unsigned char* face_z_neg, 
					TEXTURE_FORMAT format, TEXTURE_COMPONENTS components, TEXTURE_DATA_TYPE datatype, 
					SAMPLING_MODE sampling = SAMPLING_MODE::TRILINEAR, SAMPLER_WRAP_MODE wrap = SAMPLER_WRAP_MODE::CLAMP_TO_BORDER, bool srgb = false);
	~CubeMapTexture();

	void getTextureDimensions(int& width, int& height) const;
	void bind(unsigned int unit) const;
	void unbind() const;
	unsigned int getHandle() const;
	void generateMipMaps() const;
	bool isSRGBImage() const;
};

