#pragma once

#include <initializer_list>

#include "GLTypes.h"
#include "Texture2D.h"

class FBO
{
private:

	GLuint _handle;
	GLuint _renderbuffer;
	int _width, _height;

	unsigned int _nbDrawBuffers;
	GLenum* _drawBuffers;

public:

	FBO();
	~FBO();

	bool setBuffers(std::initializer_list<const Texture2D*> colorBuffers, bool depthRenderBuffer = false, const Texture2D* depthBufferTex = nullptr);
	void bind(FRAMEBUFFER_BIND_MODE mode = FRAMEBUFFER_BIND_MODE::READ_WRITE) const;
	void unbind() const;
};

