#include "IBO.h"

IBO::IBO(int size) : IBO(size, nullptr)
{
}

IBO::IBO(int size, void* data)
{
	glGenBuffers(1, &_handle);
	glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, _handle);
	glBufferData(GL_ELEMENT_ARRAY_BUFFER, size * sizeof(unsigned int), data, GL_STATIC_DRAW);
}

IBO::~IBO()
{
	glDeleteBuffers(1, &_handle);
}

void IBO::bindToVAO() const
{
	glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, _handle);
}
