#pragma once

#include "VBO.h"
#include <gtc/matrix_transform.hpp>
#include <gtx/transform.hpp>

class SSBO : public VBO
{
private:
	static const GLenum target = GL_SHADER_STORAGE_BUFFER;

	size_t _size;

public:

	// size is number of vertices, size of buffer is: size * dataType * components
	SSBO(BUFFER_TYPE type, size_t size, glm::vec4* data = 0);
	SSBO(BUFFER_TYPE type, size_t size, float* data = 0);
	virtual ~SSBO();

	void bindBase(int index);
	void unbindBase(int index);
	void unbind();

	void bindToVAO();

	glm::vec4* map(GLbitfield access = GL_MAP_READ_BIT);
	GLuint* mapGLuint(GLbitfield access = GL_MAP_READ_BIT);
	void unmap();
};

