#include "SamplerObject.h"


SamplerObject::SamplerObject(SAMPLING_MODE sample, SAMPLER_WRAP_MODE wrap)
{
	glGenSamplers(1, &_handle);

	glSamplerParameteri(_handle, GL_TEXTURE_WRAP_S, (unsigned int)wrap);
	glSamplerParameteri(_handle, GL_TEXTURE_WRAP_T, (unsigned int)wrap);
	switch (sample)
	{
		case SAMPLING_MODE::LINEAR:
			glSamplerParameteri(_handle, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
			glSamplerParameteri(_handle, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
			break;
		case SAMPLING_MODE::BILINEAR:
			glSamplerParameteri(_handle, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
			glSamplerParameteri(_handle, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
			break;
		case SAMPLING_MODE::TRILINEAR:
			glSamplerParameteri(_handle, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
			glSamplerParameteri(_handle, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR);
			break;
	}
}

SamplerObject::~SamplerObject()
{
	glDeleteSamplers(1, &_handle);
}

void SamplerObject::bind(unsigned int unit)
{
	_unit = unit;
	glBindSampler(_unit, _handle);
}

void SamplerObject::unbind()
{
	glBindSampler(_unit, 0);
}