#pragma once

#include "GLTypes.h"

class Texture3D
{
private:

	GLuint _handle;
	int _width, _height, _depth;
	const GLenum _texTarget;
	TEXTURE_FORMAT _format;

	void initTex3D(TEXTURE_FORMAT format, TEXTURE_COMPONENTS components, TEXTURE_DATA_TYPE datatype, SAMPLING_MODE sampling, SAMPLER_WRAP_MODE wrap, const void* data);

public:

	Texture3D(unsigned int width, unsigned int height, unsigned int depth, TEXTURE_FORMAT format, TEXTURE_COMPONENTS components, TEXTURE_DATA_TYPE datatype, SAMPLING_MODE sampling = SAMPLING_MODE::TRILINEAR, SAMPLER_WRAP_MODE wrap = SAMPLER_WRAP_MODE::CLAMP_TO_BORDER, bool multisampling = false);
	Texture3D(const void* data, unsigned int width, unsigned int height, unsigned int depth, TEXTURE_FORMAT format, TEXTURE_COMPONENTS components, TEXTURE_DATA_TYPE datatype, SAMPLING_MODE sampling = SAMPLING_MODE::TRILINEAR, SAMPLER_WRAP_MODE wrap = SAMPLER_WRAP_MODE::CLAMP_TO_BORDER, bool multisampling = false);

	~Texture3D();

	void getTextureDimensions(int& width, int& height, int& depth) const;
	void bind(unsigned int unit) const;
	void bindImage(unsigned int unit) const;
	void unbind() const;
	unsigned int getHandle() const;
	void generateMipMaps() const;
};

