#pragma once

#include <initializer_list>
#include <vector>

#include "VBO.h"
#include "IBO.h"

class VAO
{
private:
	GLuint _handle;

public:
	VAO();
	~VAO();

	void bind();
	void unbind();
	void setBuffers(std::initializer_list<VBO*> buffers);
	void setBuffers(IBO* indices, std::initializer_list<VBO*> buffers);
	void setBuffers(std::vector<VBO*> buffers);
	void setBuffers(IBO* indices, std::vector<VBO*> buffers);
};

