#pragma once
/**

equidistant grid with lateral length of 2radiusmax + 2Rmax
radiusMax = maximal van der vaals radius
Rmax = solvend radius, will be set to 2 per default (allows interactive change of solved radius between [0,2]
*/

#include <vector>

#include <glm.hpp>
#include <gtc/matrix_transform.hpp>

#include <iostream>

#include "GLWrapper/Texture3D.h"
#include "GLWrapper/SSBO.h"

class Grid
{
public:
	Grid(std::vector<glm::vec4> atoms, float maximumSolventRadius, float maximumAtomRadius);
	virtual ~Grid();

	SSBO* getSSBOGridData() { return _ssbo_grid_data; }
	glm::uvec3 getGridSize() { return _gridSize; }

	static const int MAX_CELL_PRE_ENTRIES;
	static const int MAX_CELL_ENTRIES;

private:

	float gridCellSize;

	void initialize(std::vector<glm::vec4> atoms);

	SSBO* _ssbo_grid_data;
	glm::uvec3 _gridSize;
};

