
#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include "ui_MainWindow.h"

#include <QMainWindow>
#include <QPushButton>
#include <QLabel>
#include <QProgressBar>
#include <QStatusBar>
#include <QVariant>

#include "GLWidget.h"

#include "PDBLoader.h"

class MainWindow : public QMainWindow
{
	Q_OBJECT

	public:

		MainWindow(QWidget *parent = 0);
		~MainWindow();

	
	protected slots :

		void								 openFileAction();
		void								 closeAction();

		void updateGLWidget();
					


	private:

		// USER INTERFACE ELEMENTS

		Ui_MainWindow						*m_Ui;


		// DATA 
				
		PDBLoader _pdbLoader;

		struct FileType
		{
			QString			filename;
		}									 m_FileType;

		GLWidget* _glwidget;
};

#endif
