#pragma once

#include <string>
#include <vector>

#include <glm.hpp>

#include <ESBTL/default.h>
#include <ESBTL/atom_classifier.h>
#include <ESBTL/weighted_atom_iterator.h>

typedef ESBTL::Generic_classifier<ESBTL::Radius_of_atom<double, ESBTL::Default_system::Atom>> T_Atom_classifier;
typedef ESBTL::Accept_none_occupancy_policy<ESBTL::PDB::Line_format<>> Accept_none_occupancy_policy;


class PDBLoader
{
private:
	std::map<std::string, float> _elemRadii;

public:
	PDBLoader();
	~PDBLoader();

	bool loadPDB(std::string file, std::vector<glm::vec4>& atom_list, std::vector<std::string>& elements, std::vector<float>& radii);
};

