#include "ShaderManager.h"

const std::string ShaderManager::BASE_DIR = "res/shader/";

ShaderManager::ShaderManager()
{	
}

ShaderManager::~ShaderManager()
{
	typedef std::map<std::string, Shader*>::iterator it_type;
	for (it_type iterator = _shaders.begin(); iterator != _shaders.end(); iterator++) {
		delete iterator->second;
	}

	for (it_type iterator = _computeShaders.begin(); iterator != _computeShaders.end(); iterator++) {
		delete iterator->second;
	}
}

Shader* ShaderManager::loadShader(std::string path)
{
	if (_shaders.find(path) == _shaders.end()) {
		_shaders[path] = new Shader(BASE_DIR + path);
	}

	return _shaders[path];
}

Shader* ShaderManager::loadComputeShader(std::string path)
{
	if (_computeShaders.find(path) == _computeShaders.end()) {
		_computeShaders[path] = new Shader(BASE_DIR + path, true);
	}

	return _computeShaders[path];
}

void ShaderManager::reloadAllShaders() 
{
	typedef std::map<std::string, Shader*>::iterator it;
	for (it i = _shaders.begin(); i != _shaders.end(); i++) {
		i->second->reload();
	}
}