#pragma once

#include <string>
#include <map>
#include <vector>

#include "../GLWrapper/Shader.h"


class ShaderManager
{
private:

	std::map<std::string, Shader*> _shaders;
	std::map<std::string, Shader*> _computeShaders;

public:
	ShaderManager();
	virtual ~ShaderManager();

	Shader* loadShader(std::string path);
	Shader* loadComputeShader(std::string path);
	void reloadAllShaders();

	static const std::string BASE_DIR;
};

