#pragma once

#include <string>

#include <glm.hpp>
#include <gtc/matrix_transform.hpp>
#include <gtx/matrix_decompose.hpp>

enum class LIGHT_TYPE { POINT, DIRECTIONAL };

class Light
{
private:

public:
	Light(std::string name, LIGHT_TYPE type, glm::vec3 direction, glm::vec3 position, glm::vec3 colorDiffuse, glm::vec3 colorSpecular, glm::vec3 attenuation)
		: name(name), type(type), direction(direction), 
			colorDiffuse(colorDiffuse), colorSpecular(colorSpecular), attenuation(attenuation), enabled(true)
	{ }
	~Light() { }

	std::string name;
	glm::vec3 position;
	glm::vec3 direction;
	glm::vec3 colorDiffuse;
	glm::vec3 colorSpecular;
	glm::vec3 attenuation; // [0] = constant, [1] = linear, [2] = quadratic
	LIGHT_TYPE type;

	bool enabled;
};

