#pragma once

#include "Mesh.h"
#include "../../../GLWrapper/VAO.h"
#include "../../material/Material.h"
#include "../../../render/RenderInfo.h"

class ScreenQuadMesh : public Mesh
{
protected:
	virtual void render_sub(RenderInfo& renderInfo) const;
	virtual void preupdate_sub(float dt);
	virtual void postupdate_sub(float dt);

public:
	enum class QUAD_CORNER {
		TOP_LEFT = 0, TOP_RIGHT = 1, BOTTOM_LEFT = 2, BOTTOM_RIGHT = 3, FULL_SCREEN = 4
	};

	ScreenQuadMesh(float width, float height, QUAD_CORNER corner, Material* material); // specify corner -> extents to border; height, width in [0, 1]
	ScreenQuadMesh(Material* material); // fullscreen quad mesh
	virtual ~ScreenQuadMesh();

	void setMaterial(Material* material);

private:
	QUAD_CORNER _corner;

	std::vector<VBO*> initBuffers(float width, float height, QUAD_CORNER quadCorner);
};

