#include "TextureMaterial.h"

#include "../graph/geometry/Mesh.h"
#include "../graph/SceneGraph.h"

TextureMaterial::TextureMaterial(Shader* shader, Texture2D* diffTex)
	: Material(shader), _diffTex(diffTex)
{
}

TextureMaterial::~TextureMaterial()
{
}

void TextureMaterial::initShaderUniforms(const SceneGraph* scene)
{
}

void TextureMaterial::render(RenderInfo& renderInfo, const glm::mat4& M, const glm::mat4& V, const glm::mat4& P) const
{
	_shader->setUniform("MVP", P * V * M);

	if (_diffTex != nullptr) {
		_shader->setUniform("diffTex", _diffTex, 0);
	}

	_shader->bind();
}