#pragma once
#include "Material.h"

#include <glm.hpp>
#include <gtc/matrix_transform.hpp>

#include "../../GLWrapper/Texture2D.h"

class TextureMaterial : public Material
{
private:
	Texture2D* _diffTex;

public:
	TextureMaterial(Shader* shader, Texture2D* diffTex);
	virtual ~TextureMaterial();

	virtual void initShaderUniforms(const SceneGraph* scene);
	virtual void render(RenderInfo& renderInfo, const glm::mat4& M, const glm::mat4& V, const glm::mat4& P) const;

};

