#pragma once
#include "Material.h"

#include <glm.hpp>
#include <gtc/matrix_transform.hpp>

#include "../../GLWrapper/Texture2D.h"

class TexturePhongMaterial : public Material
{
private:
	Texture2D* _diffTex;

public:
	TexturePhongMaterial(Shader* shader);
	TexturePhongMaterial(Shader* shader, Texture2D* diffTex);
	virtual ~TexturePhongMaterial();

	virtual void initShaderUniforms(const SceneGraph* scene);
	virtual void render(RenderInfo& renderInfo, const glm::mat4& M, const glm::mat4& V, const glm::mat4& P) const;

	const Texture2D* getDiffTex() { return _diffTex; }
	void setDiffTex(Texture2D* diffTex) { _diffTex = diffTex; }
};

