#version 430 core


uniform sampler2D depthTex;
uniform vec3 dir;

in vec2 uv;

out vec4 color;

void main() {
	vec3 baseCol = vec3(0.5);
	vec3 grad = texture(depthTex, uv).rgb;
	float z = texture(depthTex, uv).a;

	if(z == 0.0) {
		color = vec4(0.0);
		return;
	}

	vec3 n = normalize(grad * 2.0 - 1.0);
	vec3 l = normalize(vec3(0.3, 0.5, 1));

	// illumination
	vec3 ambient = baseCol;

	vec3 diffuse = max(dot(n, l), 0.0) * baseCol;

	vec3 specular = pow(max(dot(normalize(dir), -reflect(l, n)), 0.0), 4.0) * baseCol;

	
	color = vec4(0.2 * ambient + 0.6*diffuse + 0.2*specular, 1.0);
	
	// depth
	//color = vec4(vec3(texture(depthTex, uv).a), 1);

	// gradient/normal
	//color = vec4(texture(depthTex, uv).rgb * 2 - 1,1);
}
