#pragma once

class VisualDebugger;
class SceneGraph;

class Global
{
private:
	Global() { }
	~Global() { }

public:
	
	struct View {
		int windowWidth;
		int windowHeight;
		float fovY;
		float nearZ;
		float farZ;

		View() 
			: windowWidth(800), windowHeight(600), fovY(60.0f), nearZ(0.01f), farZ(100.0f)
		{ }

		View(int windowWidth_, int windowHeight_, float fovY_, float nearZ_, float farZ_) 
			: windowWidth(windowWidth_), windowHeight(windowHeight_), fovY(fovY_), nearZ(nearZ_), farZ(farZ_)
		{ }
	} view;

	VisualDebugger* visualDebugger;

	SceneGraph* sceneGraph;

	
	static Global& instance() 
	{ 
		static Global _instance;

		return _instance;
	}
};

