#include "VisualDebugger.h"


VisualDebugger::VisualDebugger()
{
	_debugQuads[0] = nullptr;
	_debugQuads[1] = nullptr;
	_debugQuads[2] = nullptr;
	_debugQuads[3] = nullptr;
}

VisualDebugger::~VisualDebugger()
{
	for (unsigned int i = 0; i < 4; i++) {
		if (_debugQuads[i] != nullptr) delete _debugQuads[i];
	}
}

void VisualDebugger::setDebugQuad(ScreenQuadMesh::QUAD_CORNER corner, TextureMaterial* mat)
{
	if (mat == nullptr) return;

	unsigned int idx = (unsigned int)corner;
	if (_debugQuads[idx] != nullptr) {
		delete _debugQuads[idx];
		_debugQuads[idx] = nullptr;
	}

	_debugQuads[idx] = new ScreenQuadMesh(0.25f, 0.25f, corner, mat);
}

void VisualDebugger::render(RenderInfo& renderinfo)
{
	for (unsigned int i = 0; i < 4; i++) {
		if (_debugQuads[i] != nullptr) 
			_debugQuads[i]->render(renderinfo, glm::mat4(1), glm::mat4(1), glm::mat4(1));
	}
}
